OGRE-Next: Ogre::HighLevelGpuProgramManager Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | List of all members
Ogre::HighLevelGpuProgramManager Class Reference
Core » Resources

This ResourceManager manages high-level vertex and fragment programs. More...

`#include <OgreHighLevelGpuProgramManager.h>`

Inheritance diagram for Ogre::HighLevelGpuProgramManager:
[legend]

## Public Types
typedef map< String, HighLevelGpuProgramFactory * >::type | FactoryMap
Public Types inherited from Ogre::ResourceManager
typedef std::pair< ResourcePtr, bool > | ResourceCreateOrRetrieveResult
typedef map< ResourceHandle, ResourcePtr >::type | ResourceHandleMap
typedef unordered_map< String, ResourcePtr >::type | ResourceMap
typedef MapIterator< ResourceHandleMap > | ResourceMapIterator
typedef unordered_map< String, ResourceMap >::type | ResourceWithGroupMap

## Public Member Functions
| HighLevelGpuProgramManager ()
| ~HighLevelGpuProgramManager () override
void | addFactory (HighLevelGpuProgramFactory *factory)
| Add a new factory object for high-level programs of a given language.
HighLevelGpuProgramPtr | createProgram (const String &name, const String &groupName, const String &language, GpuProgramType gptype)
| Create a new, unloaded HighLevelGpuProgram.
HighLevelGpuProgramPtr | getByName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Get a resource by name.
bool | isLanguageSupported (const String &lang)
| Returns whether a given high-level language is supported.
void | removeFactory (HighLevelGpuProgramFactory *factory)
| Remove a factory object for high-level programs of a given language.
Public Member Functions inherited from Ogre::ResourceManager
| ResourceManager ()
| ~ResourceManager () override
virtual void | _notifyResourceLoaded (Resource *res)
| Notify this manager that a resource which it manages has been loaded.
virtual void | _notifyResourceTouched (Resource *res)
| Notify this manager that a resource which it manages has been 'touched', i.e.
virtual void | _notifyResourceUnloaded (Resource *res)
| Notify this manager that a resource which it manages has been unloaded.
virtual ResourceCreateOrRetrieveResult | createOrRetrieve (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Create a new resource, or retrieve an existing one with the same name if it already exists.
virtual ResourcePtr | createResource (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Creates a new blank resource, but does not immediately load it.
void | destroyAllResourcePools ()
| destroy all pools
void | destroyResourcePool (const String &name)
| Destroy a resource pool.
void | destroyResourcePool (ResourcePool *pool)
| Destroy a resource pool.
virtual ResourcePtr | getByHandle (ResourceHandle handle)
| Retrieves a pointer to a resource by handle, or null if the resource does not exist.
Real | getLoadingOrder () const override
| Gets the relative loading order of resources of this type.
virtual size_t | getMemoryBudget () const
| Get the limit on the amount of memory this resource handler may use.
virtual size_t | getMemoryUsage () const
| Gets the current memory usage, in bytes.
virtual ResourcePtr | getResourceByName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Retrieves a pointer to a resource by name, or null if the resource does not exist.
ResourceMapIterator | getResourceIterator ()
| Returns an iterator over all resources in this manager.
ResourcePool * | getResourcePool (const String &name)
| Create a resource pool, or reuse one that already exists.
const String & | getResourceType () const
| Gets a string identifying the type of resource this manager handles.
const StringVector & | getScriptPatterns () const override
| Gets the file patterns which should be used to find scripts for this ResourceManager.
virtual bool | getVerbose ()
| Gets whether this manager and its resources habitually produce log output.
virtual ResourcePtr | load (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic load method, used to create a Resource specific to this ResourceManager without using one of the specialised 'load' methods (containing per-Resource-type parameters).
void | parseScript (DataStreamPtr &stream, const String &groupName) override
| Parse the definition of a set of resources from a script file.
virtual ResourcePtr | prepare (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic prepare method, used to create a Resource specific to this ResourceManager without using one of the specialised 'prepare' methods (containing per-Resource-type parameters).
void | reloadAll (bool reloadableOnly=true)
| Caused all currently loaded resources to be reloaded.
virtual void | reloadAll (Resource::LoadingFlags flags)
| Caused all currently loaded resources to be reloaded.
void | reloadUnreferencedResources (bool reloadableOnly=true)
| Caused all currently loaded but not referenced by any other object resources to be reloaded.
virtual void | remove (const ResourcePtr &r)
| Remove a single resource.
virtual void | remove (const String &name)
| Remove a single resource by name.
virtual void | remove (ResourceHandle handle)
| Remove a single resource by handle.
virtual void | removeAll ()
| Removes all resources.
virtual void | removeUnreferencedResources (bool reloadableOnly=true)
| Remove all resources which are not referenced by any other object.
virtual bool | resourceExists (const String &name)
| Returns whether the named resource exists in this manager.
virtual bool | resourceExists (ResourceHandle handle)
| Returns whether a resource with the given handle exists in this manager.
virtual void | setMemoryBudget (size_t bytes)
| Set a limit on the amount of memory this resource handler may use.
virtual void | setVerbose (bool v)
| Sets whether this manager and its resources habitually produce log output.
virtual void | unload (const String &name)
| Unloads a single resource by name.
virtual void | unload (ResourceHandle handle)
| Unloads a single resource by handle.
void | unloadAll (bool reloadableOnly=true)
| Unloads all resources.
virtual void | unloadAll (Resource::LoadingFlags flags)
| Unloads all resources.
void | unloadUnreferencedResources (bool reloadableOnly=true)
| Unload all resources which are not referenced by any other object.
Public Member Functions inherited from Ogre::ScriptLoader
virtual | ~ScriptLoader ()
Public Member Functions inherited from Ogre::Singleton< HighLevelGpuProgramManager >
| Singleton ()
| ~Singleton ()

## Static Public Member Functions
static HighLevelGpuProgramManager & | getSingleton ()
| Override standard Singleton retrieval.
static HighLevelGpuProgramManager * | getSingletonPtr ()
| Override standard Singleton retrieval.
Static Public Member Functions inherited from Ogre::Singleton< HighLevelGpuProgramManager >
static HighLevelGpuProgramManager & | getSingleton ()
static HighLevelGpuProgramManager * | getSingletonPtr ()

## Additional Inherited Members
Public Attributes inherited from Ogre::ResourceManager
| OGRE_AUTO_MUTEX

## Detailed Description

This ResourceManager manages high-level vertex and fragment programs.

Remarks
  High-level vertex and fragment programs can be used instead of assembler programs as managed by GpuProgramManager; however they typically result in a GpuProgram being created as a derivative of the high-level program. High-level programs are easier to write, and can often be API-independent, unlike assembler programs.

  This class not only manages the programs themselves, it also manages the factory classes which allow the creation of high-level programs using a variety of high-level syntaxes. Plugins can be created which register themselves as high-level program factories and as such the engine can be extended to accept virtually any kind of program provided a plugin is written.

## Member Typedef Documentation

## ◆ FactoryMap

typedef map<String,HighLevelGpuProgramFactory*>::type Ogre::HighLevelGpuProgramManager::FactoryMap

## Constructor & Destructor Documentation

## ◆ HighLevelGpuProgramManager()

Ogre::HighLevelGpuProgramManager::HighLevelGpuProgramManager | ( |  | ) |

Referenced by getSingleton(), and getSingletonPtr().

## ◆ ~HighLevelGpuProgramManager()

Ogre::HighLevelGpuProgramManager::~HighLevelGpuProgramManager | ( |  | ) |
| override

## Member Function Documentation

## ◆ addFactory()

void Ogre::HighLevelGpuProgramManager::addFactory | ( | HighLevelGpuProgramFactory * | factory | ) |

Add a new factory object for high-level programs of a given language.

## ◆ createProgram()

HighLevelGpuProgramPtr Ogre::HighLevelGpuProgramManager::createProgram | ( | const String & | name,
|  | const String & | groupName,
|  | const String & | language,
|  | GpuProgramType | gptype )

Create a new, unloaded HighLevelGpuProgram.

  This method creates a new program of the type specified as the second and third parameters. You will have to call further methods on the returned program in order to define the program fully before you can load it.

Parameters

  name | The identifying name of the program
  groupName | The name of the resource group which this program is to be a member of
  language | Code of the language to use (e.g. "cg")
  gptype | The type of program to create

## ◆ getByName()

HighLevelGpuProgramPtr Ogre::HighLevelGpuProgramManager::getByName | ( | const String & | name,
|  | const String & | groupName = ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME )

Get a resource by name.

See also
  ResourceManager::getResourceByName

References Ogre::ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME.

## ◆ getSingleton()

static HighLevelGpuProgramManager & Ogre::HighLevelGpuProgramManager::getSingleton | ( |  | ) |
| static

Override standard Singleton retrieval.

Remarks
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

References HighLevelGpuProgramManager().

## ◆ getSingletonPtr()

static HighLevelGpuProgramManager * Ogre::HighLevelGpuProgramManager::getSingletonPtr | ( |  | ) |
| static

Override standard Singleton retrieval.

Remarks
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

References HighLevelGpuProgramManager().

## ◆ isLanguageSupported()

bool Ogre::HighLevelGpuProgramManager::isLanguageSupported | ( | const String & | lang | ) |

Returns whether a given high-level language is supported.

## ◆ removeFactory()

void Ogre::HighLevelGpuProgramManager::removeFactory | ( | HighLevelGpuProgramFactory * | factory | ) |

Remove a factory object for high-level programs of a given language.

The documentation for this class was generated from the following file:

- OgreHighLevelGpuProgramManager.h